type token =
  | SEMICOLON
  | LEFT_PAREN
  | RIGHT_PAREN
  | BEGIN_STATEMENT
  | END_STATEMENT
  | LEFT_SQ_BRACKET
  | RIGHT_SQ_BRACKET
  | COMMA
  | MATRIX_POWER
  | DECIMAL_POINT
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | ASSIGNMENT
  | IS
  | EQUAL_TO
  | NOT_EQUAL_TO
  | LESS_THAN
  | LESS_THAN_EQUAL_TO
  | GREATER_THAN
  | GREATER_THAN_EQUAL_TO
  | RETURN_STATEMENT
  | IF_CONDITION
  | ELSE_CONDITION
  | FOR
  | WHILE
  | INT
  | FLOATLIT
  | VARIABLE_ASSIGNMENT
  | LITERAL of (int)
  | ID of (string)
  | FLOAT of (float)
  | MINIMUM
  | MAXIMUM
  | MEDIAN_PRICE
  | EMA_AVERAGE
  | SMA_AVERAGE
  | OPEN_PRICE
  | CLOSE_PRICE
  | HIGH_PRICE
  | LOW_PRICE
  | ERROR_TRY
  | ERROR_CATCH
  | ERROR_THROW
  | ERROR_NUM
  | BEGIN_LOOP
  | END_LOOP
  | EOF

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
